﻿using System;

namespace caldotnet
{
    #region Types
    public class Types
    {
        public static Type Void { get { return null; } }
        public static Type Object { get { return typeof(object); } }
        public static Type Bool { get { return typeof(bool); } }
        public static Type String { get { return typeof(string); } }
        public static Type Int { get { return typeof(int); } }
        public static Type Double { get { return typeof(double); } }
        public static Type Char { get { return typeof(char); } }
        public static Type Record { get { return typeof(Record); } }

        public static Type ObjectArr { get { return typeof(object[]); } }
        public static Type BoolArr { get { return typeof(bool[]); } }
        public static Type StringArr { get { return typeof(string[]); } }
        public static Type IntArr { get { return typeof(int[]); } }
        public static Type DoubleArr { get { return typeof(double[]); } }
        public static Type CharArr { get { return typeof(char[]); } }

        public static Type FromArrayType(Type t)
        {
            if (t == BoolArr)
                return Bool;
            if (t == StringArr)
                return String;
            if (t == IntArr)
                return Int;
            if (t == DoubleArr)
                return Double;
            if (t == CharArr)
                return Char;

            throw new NotImplementedException();
        }

        public static object GetDefaultValue(Type t)
        {
            if (t == Bool)
                return false;
            if (t == String)
                return "";
            if (t == Int)
                return 0;
            if (t == Double)
                return 0;
            if (t == Char)
                return 0;

            throw new NotImplementedException();
        }
    }
    #endregion
}
