// DBWrapper.cs created with MonoDevelop
// User: trag at 20:36 20.02.2009
//
// To change standard headers go to Edit->Preferences->Coding->Standard Headers
//
using System;
using System.Collections;
using System.Data;
using System.Data.Common;
using Mono.Data.SqliteClient;

using caldotnet;

namespace sqlitecal
{
	
	
	public class DBWrapper : IDBWrapper
	{
        private SqliteConnection conn;
        private string connectionString;
        private DBInfo dbInfo;

		public DBWrapper(string settings)
		{
			connectionString = settings;
			conn = new SqliteConnection(connectionString);
			conn.Open();
		}

		public DBInfo GetDBInfo ()
		{
			int i = 0;
			int j;			
			SqliteDataAdapter da = new SqliteDataAdapter();
			da.SelectCommand = new SqliteCommand("SELECT name FROM SQLITE_MASTER where type='table'", conn);			
			DataTable dt = new DataTable();
			DataTable fieldTable = new DataTable();
			
			da.Fill(dt);
			
			dbInfo = new DBInfo();
			dbInfo.Tables = new TableInfo[dt.Rows.Count];

			foreach (DataRow dr in dt.Rows)
			{
				string tableName = dr.ItemArray[0].ToString();
				
				TableInfo Ti = new TableInfo();
				
				Ti.TableName = tableName;
				dbInfo.Tables[i] = Ti;
				
				da.SelectCommand = new SqliteCommand(String.Format("PRAGMA TABLE_INFO({0})", tableName), conn);
				fieldTable.Clear();
				da.Fill(fieldTable);
				Ti.Fields = new FieldInfo[fieldTable.Rows.Count];
				j = 0;
				
				foreach (DataRow fieldTableRow in fieldTable.Rows)
				{
					string fieldname = fieldTableRow.ItemArray[1].ToString();
					FieldInfo finfo = new FieldInfo();
					Ti.Fields[j] = finfo;
					finfo.Name = fieldname;
					finfo.DBMSTypeName = fieldTableRow.ItemArray[2].ToString();
					finfo.CALType = mapDBMSTypeToCALType(finfo.DBMSTypeName);
					finfo.MaxLen = 0;
					finfo.Precision = 0;
					finfo.Scale = 0;
					j++;				
				}

				// TODO
				Ti.PrimaryKeyFields = new string[0];
				Ti.ForeignKeys = new ForeignKey[0];
			}
				
			return dbInfo;
			
		}

		public void Rollback ()
		{
			throw new NotImplementedException();
		}

		public void Commit ()
		{
			throw new NotImplementedException();
		}

		public DataTable Query (string query)
		{
            DataTable dt = new DataTable();
            SqliteDataAdapter adapter = new SqliteDataAdapter(query, conn);

            if (conn.State != ConnectionState.Open)
                conn.Open();

            adapter.Fill(dt);

            return dt;
		}

		public DataTable Query (string query, DBParam[] parameters)
		{	
            if (conn.State != ConnectionState.Open)
                conn.Open();

            DataTable dt = new DataTable();
            SqliteCommand cmd = new SqliteCommand(query, conn);

            for (int i = 0; i < parameters.Length; i++)
                cmd.Parameters.Add(parameters[i].paramName, parameters[i].value);

            SqliteDataAdapter adapter = new SqliteDataAdapter(cmd);
            adapter.Fill(dt);

            return dt;

		}

		public void QueryNoResult (string query)
		{
            if (conn.State != ConnectionState.Open)
                conn.Open();

            SqliteCommand cmd = new SqliteCommand(query, conn);

            cmd.ExecuteNonQuery();
		}

		public void QueryNoResult (string query, DBParam[] parameters)
		{
            if (conn.State != ConnectionState.Open)
                conn.Open();

            SqliteCommand cmd = new SqliteCommand(query, conn);

            for (int i = 0; i < parameters.Length; i++)
                cmd.Parameters.Add(parameters[i].paramName, parameters[i].value);

            cmd.ExecuteNonQuery();
		}
		
		internal Type mapDBMSTypeToCALType(string dbmsType)
        {
            switch (dbmsType)
            {
                case "INTEGER": return Types.Int;
                case "FLOAT": return Types.Double;
			    case "DECIMAL": return Types.Double;
                default:
				    if (dbmsType.ToLower().StartsWith("varchar("))
				    {
					    return Types.String;
				    }
					
                    throw new Exception("Sqlite Type not supported: " + dbmsType);
            }
        }

	}
}
