﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace TestProgram
{
    public partial class Form1 : Form
    {
        Random rnd = new Random();
        public Form1()
        {
            InitializeComponent();
            
            TestProgramCALCode.OnInit();

            cmsGrupes.ItemClicked += new ToolStripItemClickedEventHandler(cmsGrupes_ItemClicked);
            updateGroups();
            cbAtaskaitos.SelectedIndex = 0;

            dtpNuo.Value = new DateTime(2007, 12, 1);
            dtpIki.Value = new DateTime(2008, 11, 30);
        }

        void updateGroups()
        {
            TestProgramCALCode.GautiGrupes();

            DataTable grupes = TestProgramCALCode.grupes.GetData();

            lbGrupes.Items.Clear();
            cmsGrupes.Items.Clear();

            foreach (DataRow dr in grupes.Rows)
            {
                string grupe = (string)dr[0];
                cmsGrupes.Items.Add(grupe).Tag = grupe;
                lbGrupes.Items.Add(grupe);
            }
        }

        void cmsGrupes_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            string str = (string)e.ClickedItem.Tag;

            if ((int)cmsGrupes.Tag == 1)
            {
                if (str.Contains(' '))
                    str = string.Format("'{0}'", str);

                txtGrupe.Text += str;
            }
            else
                if ((int)cmsGrupes.Tag == 2)
                {
                    txtigrupe.Text = str;
                }
                else
                {
                    if (str.Contains(' '))
                        str = string.Format("'{0}'", str);

                    txttGrupe.Text += str;
                }
        }

        private void btnIeskoti_Click(object sender, EventArgs e)
        {
            TestProgramCALCode.Filtrai(txtData.Text, txtGrupe.Text, txtSuma.Text, txtPastabos.Text);

            dgvDuomenys.DataSource = null;

            switch (cbAtaskaitos.SelectedIndex)
            {
                case 1:
                    TestProgramCALCode.Didziausi();
                    break;
                case 2:
                    TestProgramCALCode.PagalGrupes();
                    dgvDuomenys.DataSource = TestProgramCALCode.pagalGr.GetData();
                    break;
            }

            if ((cbAtaskaitos.SelectedIndex == 0) || (cbAtaskaitos.SelectedIndex == 1))
            {
                TestProgramCALCode.GautiIrasus();
                dgvDuomenys.DataSource = TestProgramCALCode.irasai.GetData();

                dgvDuomenys.Columns[0].Width = 30;
                dgvDuomenys.Columns[1].Width = 70;
                dgvDuomenys.Columns[3].Width = 50;
                dgvDuomenys.Columns[4].Width = 200;
            }

            lblViso.Text = TestProgramCALCode.total.ToString() + " Lt";
        }

        private void btnGrupes_Click(object sender, EventArgs e)
        {
            cmsGrupes.Tag = 1;
            cmsGrupes.Show(btnGrupes, 0, btnGrupes.Height);
        }

        private void btnTrintiGr_Click(object sender, EventArgs e)
        {
            if (lbGrupes.SelectedIndex == -1)
                return;

            string grupe = (string)lbGrupes.SelectedItem;

            if (TestProgramCALCode.TrintiGrupe(grupe) == 0)
                MessageBox.Show("Grupės ištrinti nepavyko. Greičiausiai tokia jau naudojama įrašuose.");

            updateGroups();
        }

        private void btnIvGr_Click(object sender, EventArgs e)
        {
            if (txtNaujaGrupe.Text.Trim() == string.Empty)
                return;

            if (TestProgramCALCode.PridetiGrupe(txtNaujaGrupe.Text) == 0)
                MessageBox.Show("Grupės pridėti nepavyko. Greičiausiai tokia jau yra.");

            updateGroups();
        }

        private void btnTrinti_Click(object sender, EventArgs e)
        {
            TestProgramCALCode.TrintiIrasa(int.Parse(txtIrasas.Text));
        }

        private void btnIvesti_Click(object sender, EventArgs e)
        {
            if (TestProgramCALCode.IvestiIrasa(int.Parse(txtidata.Text), txtigrupe.Text, double.Parse(txtisuma.Text), txtipastabos.Text) == 0)
                MessageBox.Show("Nepavyko įvesti grupės. Galbūt įvedėte neegzistuojančią grupę?");
        }

        private void btnIGrupes_Click(object sender, EventArgs e)
        {
            cmsGrupes.Tag = 2;
            cmsGrupes.Show(btnIGrupes, 0, btnIGrupes.Height);
        }

        private void btnTIeskoti_Click(object sender, EventArgs e)
        {
            if (dtpNuo.Value > dtpIki.Value)
            {
                MessageBox.Show("Data nuo yra didesnė už datą iki.");
                return;
            }

            int dNuo = dtpNuo.Value.Year * 10000 + dtpNuo.Value.Month * 100 + dtpNuo.Value.Day;
            int dIki = dtpIki.Value.Year * 10000 + dtpIki.Value.Month * 100 + dtpIki.Value.Day;

            TestProgramCALCode.Filtrai(dNuo.ToString() + ".." + dIki.ToString(), txttGrupe.Text, txttSuma.Text, txttPastabos.Text);
            TestProgramCALCode.PagalGrupesIrMenesius();

            // Surinkti duomenis pagal menesius i viena lentele
            DataTable dt = new DataTable();
            dt.Columns.Add("Grupe", typeof(string));

            DateTime date = dtpNuo.Value;

            while ((dtpIki.Value.Year > date.Year) || (dtpIki.Value.Month >= date.Month))
            {
                dt.Columns.Add((date.Year * 100 + date.Month).ToString(), typeof(double)).DefaultValue = 0;
                date = date.AddMonths(1);
            };

            DataTable data = TestProgramCALCode.pagalGrMen.GetData();

            bool yraGrupe;
            foreach (DataRow dr in data.Rows)
            {
                yraGrupe = false;
                foreach (DataRow dro in dt.Rows)
                    if ((string)dro["Grupe"] == (string)dr["Grupe"])
                    {
                        dro[dr["Menuo"].ToString()] = dr["Suma"];
                        yraGrupe = true;
                        break;
                    }

                if (!yraGrupe)
                {
                    DataRow ndr = dt.NewRow();
                    ndr["Grupe"] = (string)dr["Grupe"];
                    ndr[dr["Menuo"].ToString()] = dr["Suma"];
                    dt.Rows.Add(ndr);
                }
            }

            dgviData.DataSource = null;
            dgviData.DataSource = dt;
            
            lbltViso.Text = TestProgramCALCode.total.ToString() + " Lt";

            rtbRekomendacijos.Text = TestProgramCALCode.Taupyti().Replace('|', '\n');
        }

        private void btntGrupes_Click(object sender, EventArgs e)
        {
            cmsGrupes.Tag = 3;
            cmsGrupes.Show(btntGrupes, 0, btntGrupes.Height);
        }

        private void dgviData_Click(object sender, EventArgs e)
        {
            pbGraph.Image = new Bitmap(pbGraph.Width, pbGraph.Height);
            Graphics gr = Graphics.FromImage(pbGraph.Image);

            gr.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias;
            gr.Clear(Color.White);

            DataTable dt = (DataTable)dgviData.DataSource;
            Point[] points = new Point[dt.Columns.Count - 1];

            double max = 0;

            foreach (DataGridViewRow row in dgviData.SelectedRows)
            {
                for (int i = 1; i <= points.Length; i++)
                    if (max < (double)dt.Rows[row.Index][i])
                        max = (double)dt.Rows[row.Index][i];
            }

            foreach (DataGridViewRow row in dgviData.SelectedRows)
            {
                Pen pen = new Pen(Color.FromArgb(rnd.Next(255), rnd.Next(255), rnd.Next(255)), 3);

                for (int i = 0; i < points.Length; i++)
                {
                    double val = (double)dt.Rows[row.Index][i + 1];
                    points[i] = new Point(
                        (int)Math.Round((double)i * (pbGraph.Width - 20) / (points.Length - 1) + 10),
                        (int)Math.Round(pbGraph.Height - 10 - val / max * (pbGraph.Height - 20)));

                    gr.DrawEllipse(pen, points[i].X - 2, points[i].Y - 2, 4, 4);
                }

                gr.DrawCurve(pen, points);
            }

            Pen linePen = new Pen(Color.Red, 1);
            gr.DrawLine(linePen, 10, 10, pbGraph.Width - 10, 10);
            gr.DrawLine(linePen, 10, pbGraph.Height - 10, pbGraph.Width - 10, pbGraph.Height - 10);

            Font font = new Font("verdana", 12.00f, FontStyle.Bold);
            gr.DrawString("0", font, linePen.Brush, 10, pbGraph.Height - 30);
            gr.DrawString(Math.Round(max).ToString(), font, linePen.Brush, 10, 15);
        }
    }
}
